diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/ircd.c ircd-devel/lib/ircd.c
--- ircd-comstud-1.12-REL/lib/ircd.c	Mon Oct 23 01:13:04 2000
+++ ircd-devel/lib/ircd.c	Sun Dec 10 08:39:31 2000
@@ -26,7 +26,6 @@
 
 RCSID("$Id: ircd.c,v 1.34 1999/02/23 07:57:20 cbehrens Exp $");
 
-
 typedef struct _ircd_data	IRCD_DATA;
 
 struct _ircd_data
@@ -36,12 +35,6 @@
 	/* LEAVE THE ABOVE 3 FIRST AND NEVER CHANGE !!! */
 
 	int				ircd_pagesize;
-	int				Fdlist_num;
-	FDLIST			*Fdlist_main;
-	FDLIST			*Fdlist_clients;
-	int				*Fdlist_lasttime;
-	IRCD_CONN		**Fds;				/* for easy fd -> client lookup */
-	int				Fds_size;
 	IRCD_CLIENT		*Locals;
 	IRCD_AUTH		*Auths;
 	IRCD_CLIENT		**Clients;
@@ -52,9 +45,8 @@
 	GLOBALSTATS		*Globalinfo;
 	IRCD_REJECTHOLD	*Rejectholds;
 	IRCD_MOTD		*Motd;
-	int				Sendbuffersize;
-	int				Recvbuffersize;
 
+	int			Fds_size;
 	unsigned int	*Sentalong;
 	unsigned int	Sentalong_marker;
 	unsigned int	*Sentalong_end;
@@ -96,14 +88,9 @@
 
 int				Auths_did_delete = 0;
 int				Flooders_did_delete = 0;
-int				Fdlist_num = 100;
 char			*Conffile;
+int			Fds_size;
 int				ircd_pagesize;
-FDLIST			*Fdlist_main;
-static FDLIST	*Fdlist_clients;
-static int		*Fdlist_lasttime;
-int				Fds_size;
-IRCD_CONN		**Fds;				/* for easy fd -> client lookup */
 IRCDRES_REQLIST	*Reqlist = NULL;
 IRCD_CLIENT		*Locals = NULL;			/* local clients */
 IRCD_AUTH		*Auths = NULL;
@@ -115,8 +102,6 @@
 GLOBALSTATS		*Globalinfo;
 IRCD_REJECTHOLD	*Rejectholds = NULL;
 IRCD_MOTD		*Motd = NULL;
-int				Sendbuffersize = 0;
-int				Recvbuffersize = 0;
 unsigned int	*Sentalong;
 unsigned int	Sentalong_marker;
 unsigned int	*Sentalong_end;
@@ -132,14 +117,19 @@
 int				Rehashed = 0;
 int				Autoconncheck = 0;
 int				DoReload = 0;
-
+int			kqsock;
+int			Fds_size;
 
 static char		*ircdcore_versionstring;
 static int		*ircdcore_data_format_version;
 static char		**ircdcore_data;
 static int		*ircdcore_data_size;
-static FDLIST_POLLFD *_pfdarray = NULL;
-static int		_pfdarray_size = 0;
+
+struct kevent		*kqchange = NULL;
+struct kevent		*kqevent = NULL;
+int			kqchangesize = 0;
+int			kqchangepos = 0;
+int			kqeventsize = 0;
 
 char	_ircdso_versionstring[] = VERSION;
 int		_ircdso_version = 1;
@@ -147,7 +137,7 @@
 
 static RETSIGTYPE _ircd_sighup_handler(int sig);
 static int _auth_process(IRCD_AUTH *aptr);
-static int _ircd_pollfds(FDLIST *fdlist, int secs);
+static int _ircd_pollfds(int kqsock, int secs);
 static void flood_check(void);
 static void dns_check(void);
 static void auth_check(void);
@@ -228,121 +218,140 @@
 	return 0;
 }
 
-static int _ircd_pollfds(FDLIST *fdlist, int secs)
+static void _ircd_accept_listener(IRCD_CONN *cptr, int backlog)
+{
+	IRCD_LISTENER		*lptr = (IRCD_LISTENER *)cptr->conn_ptr;
+	struct sockaddr_in	sin;
+	int			sinsize = sizeof(sin);
+	int 			ipaddr;
+	int			i, ret;
+
+	for(i=0;i<backlog;++i) {
+		if ((ret = accept(cptr->fd, (struct sockaddr *)&sin, &sinsize)) < 0)
+			return;
+		lptr->l_lasttime = Now;
+		ipaddr = ntohl(sin.sin_addr.s_addr);
+		if (iphash_handle_accept(ipaddr))
+		{
+			int num;
+
+			if ((num=(int)vars_value_get_bynum(IRCD_VAR_REJECT_HOLD)) > 0)
+				if (client_add_rejecthold(ret, &sin) >= 0)
+					return;
+			close(ret);
+			return;
+		}
+
+		if (!access_match_ipaddr(&(_ircd_conf.deny), NULL, NULL, ipaddr, 0, NULL))
+		{
+			DEBUG(DEBUG_ALL, ("denying accept from %s\n", inet_ntoa(sin.sin_addr)));
+			close(ret);
+		}
+		else if (client_add_local(lptr, ret, &sin) < 0)
+			close(ret);
+	}
+
+	return;
+}
+
+static IRCD_CONN *_ircd_client_dead(IRCD_CONN *cptr, char *reason)
+{
+	IRCD_CONN *tmp;
+
+	if (!IsAuth(cptr))
+	{
+		conn_del(meptr, cptr, reason);
+		return NULL;
+	}
+
+	/* auth is done. */
+	tmp = ((IRCD_AUTH *)cptr->conn_ptr)->a_clptr->c_connptr;
+	conn_del(meptr, cptr, reason);
+	return tmp;
+}
+
+static int _ircd_pollfds(int kqsock, int secs)
 {
 	register int	i;
-	int				numfds;
 	int				ret;
-	int				nfds;
+	int				events;
 	static char		readbuf[1024*64];
 	static int		readbufsize = 1024*64;
 	IRCD_CONN		*cptr;
 	char			exitbuf[512];
+	struct timespec	timeout = { secs, 0 };
 
-	if (!fdlist->pfd_num)
+	if (!Fds_size)
 		return 0;
 
-	if (fdlist->pfd_num > _pfdarray_size)
+	if (Fds_size > kqeventsize)
 	{
-		FDLIST_POLLFD 	*tmp;
-
-		_pfdarray_size = fdlist->pfd_num + 64;
-		tmp = (FDLIST_POLLFD *)MyRealloc(_pfdarray,
-					_pfdarray_size * sizeof(FDLIST_POLLFD));
-		if (!tmp)
+		kqeventsize = Fds_size + 1024;
+		kqevent = fdlist_kqueue_increase(kqevent, kqeventsize);
+		if (kqevent == NULL)
 			return -ENOMEM;
-		_pfdarray = tmp;
 	}
 
-	BCOPY(fdlist->pfd_array, _pfdarray, sizeof(FDLIST_POLLFD)*fdlist->pfd_num); 
-	numfds = fdlist->pfd_num;
-
-	nfds = poll(_pfdarray, numfds, secs*1000);
+	events = kevent(kqsock, kqchange, kqchangepos, kqevent, kqeventsize, &timeout);
+	kqchangepos = 0;
 	Now = time(NULL);
-	if (nfds < 0) /* lets return on EINTR/EAGAIN also */
-	{
-		return nfds;
-	}
-	for(i=0;nfds && i<numfds;i++)
+
+	for(i=0;i<events;++i)
 	{
-		if (!_pfdarray[i].revents)
-			continue;
-		nfds--;
-		if ((cptr = GET_FDS(_pfdarray[i].fd)) == NULL)
+		if ((cptr = (IRCD_CONN *)kqevent[i].udata) == NULL)
 			continue;
+
 		cptr->conn_lasttime = Now;
-		if (IsRes(cptr))
+
+		if (kqevent[i].flags == EV_EOF)
 		{
-			(void)ircdres_get_answer((IRCDRES *)cptr->conn_ptr);
-			continue;
+			cptr = _ircd_client_dead(cptr, "EOF of client");
+			if (cptr == NULL)
+				continue;
 		}
-		if (_pfdarray[i].revents & ~(POLLIN|POLLOUT)) /* some error */
-			_pfdarray[i].revents |= POLLIN; /* will close() upon read()*/
-		if (_pfdarray[i].revents & POLLIN)
+		else if (kqevent[i].flags == EV_ERROR)
 		{
-			if (IsListener(cptr))
-			{
-				IRCD_LISTENER		*lptr = (IRCD_LISTENER *)cptr->conn_ptr;
-				struct sockaddr_in	sin;
-				int					sinsize = sizeof(sin);
-				int 				ipaddr;
-
-				ret = accept(cptr->fdlistinfo.fd,
-							(struct sockaddr *)&sin, &sinsize);
-				if (ret < 0)
-					continue;
-				lptr->l_lasttime = Now;
-				ipaddr = ntohl(sin.sin_addr.s_addr);
-				if (iphash_handle_accept(ipaddr))
-				{
-					int num;
+			if (kqevent[i].data == EBADF)
+				continue;
 
-					if ((num=(int)vars_value_get_bynum(IRCD_VAR_REJECT_HOLD)) > 0)
-					{
-						if (client_add_rejecthold(ret, &sin) >= 0)
-							continue;
-					}
-					close(ret);
-					continue;
-				}
+			cptr = _ircd_client_dead(cptr, "kqueue failure");
+			if (cptr == NULL)
+				continue;
+		}
 
-				if (!access_match_ipaddr(&(_ircd_conf.deny),
-					NULL, NULL, ipaddr, 0, NULL))
-				{
-					DEBUG(DEBUG_ALL, ("denying accept from %s\n",
-						inet_ntoa(sin.sin_addr)));
-					close(ret);
-				}
-				else if (client_add_local(lptr, ret, &sin) < 0)
-					close(ret);
+		if (kqevent[i].filter == EVFILT_READ)
+		{
+			if (IsRes(cptr))
+			{
+				(void)ircdres_get_answer((IRCDRES *)cptr->conn_ptr);
 				continue;
 			}
-			ret = read(cptr->fdlistinfo.fd, readbuf, readbufsize-1);
-			if ((ret < 0) && 
-					((errno == EAGAIN) || (errno == EINTR)
-						|| (errno == EWOULDBLOCK)))
+			if (IsListener(cptr))
+			{
+				_ircd_accept_listener(cptr, kqevent[i].data);
 				continue;
+			}
+
+			ret = read(cptr->fd, readbuf, readbufsize-1);
+
+			if ((ret < 0) && ((errno == EAGAIN) || (errno == EINTR) || (errno == EWOULDBLOCK)))
+				continue;
+
 			if (ret <= 0)
 			{
-				IRCD_CONN	*cptrkeep;
-
 				if (ret == 0)
 					sprintf(exitbuf, "EOF of client");
 				else
 					sprintf(exitbuf, "Read error %i: %s", errno,
 						(errno == 0) ? "Undefined error" : 
 								support_strerror(errno));
-				if (!IsAuth(cptr))
-				{
-					conn_del(meptr, cptr, exitbuf);
+
+				cptr = _ircd_client_dead(cptr, exitbuf);
+				if (cptr == NULL)
 					continue;
-				}
-				/* auth is done. */
-				cptrkeep = ((IRCD_AUTH *)cptr->conn_ptr)->a_clptr->c_connptr;
-				conn_del(meptr, cptr, exitbuf);
-				cptr = cptrkeep; /* fall through to the ircd_parse */
+
 				if ((int)vars_value_get_bynum(IRCD_VAR_SHOW_HEADERS))
-					send_to_client((IRCD_CLIENT *)cptr->conn_ptr, "NOTICE * :*** Ident request failed.");
+					send_to_client((IRCD_CLIENT *)cptr->conn_ptr, "NOTICE AUTH :*** Ident request failed.");
 			}
 			else
 				readbuf[ret] = '\0';
@@ -364,17 +373,16 @@
 						Globalinfo->bw_c_incoming_bytes += ret;
 
 						if (_auth_process(aptr) < 0)
-						{
 							continue;
-						}
+
 						if (sh)
-							send_to_client((IRCD_CLIENT *)cptrkeep->conn_ptr, "NOTICE * :*** Ident reply received.");
+							send_to_client((IRCD_CLIENT *)cptrkeep->conn_ptr, "NOTICE AUTH :*** Ident reply received.");
 						conn_del(meptr, cptr, "Auth Done.");
 					}
 					else
 					{
 						if (sh)
-							send_to_client((IRCD_CLIENT *)cptrkeep->conn_ptr, "NOTICE * :*** Ident request failed: add2queue failed.");
+							send_to_client((IRCD_CLIENT *)cptrkeep->conn_ptr, "NOTICE AUTH :*** Ident request failed: add2queue failed.");
 						conn_del(meptr, cptr, "Couldn't add to RecvQ");
 					}
 					cptr = cptrkeep; /* fall through to the ircd_parse */
@@ -435,7 +443,7 @@
 				}
 			}
 		}
-		if (_pfdarray[i].revents & POLLOUT)
+		else if (kqevent[i].filter == EVFILT_WRITE)
 		{
 			if (IsAuth(cptr))
 			{
@@ -444,19 +452,22 @@
 				int			len;
 				int			sh = (int)vars_value_get_bynum(IRCD_VAR_SHOW_HEADERS);
 
+				if (aptr == NULL)
+					continue;
+
 				if (sh)
-					send_to_client(aptr->a_clptr, "NOTICE * :*** Sending ident request...");
+					send_to_client(aptr->a_clptr, "NOTICE AUTH :*** Sending ident request...");
 				sprintf(buffer, "%u , %u\r\n",
 						(unsigned int)aptr->a_clptr->c_rem_port,
 						(unsigned int)aptr->a_clptr->c_loc_port);
 				len = strlen(buffer);
-				if (write(cptr->fdlistinfo.fd, buffer, len) != len)
+				if (write(cptr->fd, buffer, len) != len)
 				{
 					IRCD_CONN *cptrkeep = aptr->a_clptr->c_connptr;
 					conn_del(meptr, cptr, "write error");
 					cptr = cptrkeep; /* fall through */
 					if (sh)
-						send_to_client((IRCD_CLIENT *)cptr->conn_ptr, "NOTICE * :*** Ident request failed.");
+						send_to_client((IRCD_CLIENT *)cptr->conn_ptr, "NOTICE AUTH :*** Ident request failed.");
 					if (IsCClient(cptr))
 					{
 						IRCD_CLIENT	*clptr = (IRCD_CLIENT *)cptr->conn_ptr;
@@ -476,9 +487,7 @@
 				}
 				else
 				{
-					fdlist_del_event(cptr->fdlistinfo.fdlist,
-						cptr->fdlistinfo.fdlist_pos,
-						FDLIST_FLAGS_WRITE);
+					fdlist_del_event(cptr, FDLIST_FLAGS_WRITE);
 					continue;
 				}
 			}
@@ -490,9 +499,7 @@
 				{
 					clptr->c_flags &= ~CLIENT_FLAGS_DOINGCONNECT;
 					if (!clptr->c_queue_out.queue_size) /* should be false */
-						fdlist_del_event(cptr->fdlistinfo.fdlist,
-							cptr->fdlistinfo.fdlist_pos,
-							FDLIST_FLAGS_WRITE);
+						fdlist_del_event(cptr, FDLIST_FLAGS_WRITE);
 				}
 				if ((clptr->c_maxsendq != -1) &&
 					(clptr->c_queue_out.queue_size > clptr->c_maxsendq))
@@ -578,7 +585,7 @@
 				IRCD_CLIENT	*clptr = aptr->a_clptr;
 
 				if (sh)
-					send_to_client(clptr, "NOTICE * :*** Ident request failed: Timed out");
+					send_to_client(clptr, "NOTICE AUTH :*** Ident request failed: Timed out");
 				auth_del(meptr, aptr, "Auth timeout.");
 				if (!IsDoingDns(clptr))
 				{
@@ -631,7 +638,7 @@
 				*/
 				ircdres_request_del(pptr->c_res_req->rl_req, 0);
 				if (sh)
-					send_to_client(pptr, "NOTICE * :*** %s DNS request failed: Timed out",
+					send_to_client(pptr, "NOTICE AUTH :*** %s DNS request failed: Timed out",
 							type == T_PTR ? "Reverse" : "Forward");
 				pptr->c_res_req->rl_req = NULL;
 				del_reqlist_from_list(&Reqlist, pptr->c_res_req);
@@ -674,49 +681,6 @@
 				pptr->c_flags |= CLIENT_FLAGS_PINGSENT;
 			}
 		}
-		/* fdlist check */
-		if (IsClient(pptr))
-		{
-			int		fdlistnum = Now - pptr->c_idletime;
-			FDLIST	*fdlist = Fdlist_main;
-			int		mfd;
-			int		ret;
-			int		flags;
-			int		nfdlists;
-			int		ptime;
-
-			if (!IsAnOper(pptr) && ((nfdlists = (int)vars_value_get_bynum(IRCD_VAR_PRIORITY_FDLISTS)) > 0))
-			{
-				ptime = (int)vars_value_get_bynum(IRCD_VAR_PRIORITY_IDLE);
-				fdlistnum /= ptime;
-				if (fdlistnum > 0)
-				{
-					fdlistnum--;
-					if (fdlistnum >= nfdlists)
-						fdlistnum = nfdlists - 1;
-					fdlist = &Fdlist_clients[fdlistnum];
-				}
-			}
-			if (pptr->c_connptr->fdlistinfo.fdlist != fdlist)
-			{
-				flags = fdlist_get_events(pptr->c_connptr->fdlistinfo.fdlist,
-					pptr->c_connptr->fdlistinfo.fdlist_pos);
-				assert(flags);
-				ret = fdlist_del_fd(pptr->c_connptr->fdlistinfo.fdlist,
-                        pptr->c_connptr->fdlistinfo.fdlist_pos, &mfd);
-				if (mfd >= 0)
-				{
-					if (GET_FDS(mfd))
-						GET_FDS(mfd)->fdlistinfo.fdlist_pos =
-	                        pptr->c_connptr->fdlistinfo.fdlist_pos;
-				}
-				ret = ircd_open_fd(pptr->c_connptr->fdlistinfo.fd, flags, pptr->c_connptr, fdlist);
-				if (ret < 0)
-				{
-					client_del(meptr, pptr, "Fdlist problem");
-				}
-			}
-		}
 	}
 }
 
@@ -881,9 +845,6 @@
 static int _ircdso_firsttime(char *conf_file)
 {
 	int				ret;
-	register int	i;
-	int				opt;
-	int				optlen;
 
 	Ircd_zero_fd = open("/dev/zero", O_RDWR);
 	if (Ircd_zero_fd < 0)
@@ -892,64 +853,11 @@
 		exit(-1);
 	}
 
-	if ((i = socket(AF_INET, SOCK_STREAM, 0)) < 0)
-	{
-		fprintf(stderr, "couldn't socket(): %i\n", -errno);
-		exit(-1);
-	}
-
-	optlen = sizeof(opt);
-	if (getsockopt(i, SOL_SOCKET, SO_RCVBUF, (char *)&opt, &optlen) < 0)
-	{
-		fprintf(stderr, "couldn't getsockopt(): %i\n", -errno);
-		exit(-1);
-	}
-
-	while(setsockopt(i, SOL_SOCKET, SO_RCVBUF, (char *)&opt, sizeof(opt)) >= 0)
-	{
-		opt += 1024;
-		if (opt > (64*1024))
-			break;
-	}
-
-	optlen = sizeof(opt);
-	if (getsockopt(i, SOL_SOCKET, SO_RCVBUF, (char *)&opt, &optlen) < 0)
-	{
-		fprintf(stderr, "couldn't getsockopt(): %i\n", -errno);
-		exit(-1);
-	}
-
-	Recvbuffersize = opt;
-
-	optlen = sizeof(opt);
-	if (getsockopt(i, SOL_SOCKET, SO_SNDBUF, (char *)&opt, &optlen) < 0)
-	{
-		fprintf(stderr, "couldn't getsockopt(): %i\n", -errno);
-		exit(-1);
-	}
-
-	while(setsockopt(i, SOL_SOCKET, SO_SNDBUF, (char *)&opt, sizeof(opt)) >= 0)
-	{
-		opt += 1024;
-		if (opt > (64*1024))
-			break;
-	}
-
-	optlen = sizeof(opt);
-	if (getsockopt(i, SOL_SOCKET, SO_SNDBUF, (char *)&opt, &optlen) < 0)
-	{
-		fprintf(stderr, "couldn't getsockopt(): %i\n", -errno);
-		exit(-1);
-	}
-
-	Sendbuffersize = opt;
-	close(i);
 
 	Conffile = MyStrdup(conf_file);
 
 	meptr = (IRCD_CLIENT *)MyMalloc(sizeof(IRCD_CLIENT));
 	Fds_size = 1024;
-	Fds = (IRCD_CONN **)MyMalloc(sizeof(IRCD_CONN *) * Fds_size);
 	Sentalong_size = 1024;
 	Sentalong = (int *)MyMalloc(sizeof(int) * Sentalong_size);
 	Sentalong_marker = 0;
@@ -961,11 +869,6 @@
 			Globalinfo->m_totclientstime = (int)time(NULL);
 	Globalinfo->g_servers = 1;
 
-	Fdlist_num = 100;
-	Fdlist_main = (FDLIST *)MyMalloc(sizeof(FDLIST));
-	Fdlist_clients = (FDLIST *)MyMalloc(sizeof(FDLIST) * Fdlist_num);
-	Fdlist_lasttime = (int *)MyMalloc(sizeof(int) * Fdlist_num);
-
 	Flooders = (IRCD_CLIENT **)MyMalloc(sizeof(IRCD_CLIENT *));
 	Clients = (IRCD_CLIENT **)MyMalloc(sizeof(IRCD_CLIENT *));
 	Opers = (IRCD_CLIENT **)MyMalloc(sizeof(IRCD_CLIENT *));
@@ -974,6 +877,12 @@
 	Ircd_resconn = (IRCD_CONN *)MyMalloc(sizeof(IRCD_CONN));
 	Ircd_resconn->conn_type = IRCD_CONN_TYPE_RES;
 
+	if ((kqsock = kqueue()) < 0)
+	{
+		fprintf(stderr, "Couldn't allocate a kqueue\n");
+		exit(-1);
+	}
+
 	ret = ircdres_init((IRCDRES **)(&(Ircd_resconn->conn_ptr)));
 	if (ret < 0)
 	{
@@ -981,7 +890,7 @@
 		exit(-1);
 	}
 
-#if 0
+#if 1
 	ircd_pagesize = ircd_getpagesize();
 #else
 	ircd_pagesize = 2*1024;
@@ -990,17 +899,9 @@
 	vars_init();
 	numeric_init();
 	ircdconf_init(&_ircd_conf);
-	fdlist_init(Fdlist_main);
-
-	for(i=0;i<Fdlist_num;i++)
-	{
-		fdlist_init(&Fdlist_clients[i]);
-		Fdlist_lasttime[i] = 0;
-	}
-
 	iphash_init();
 
-	if (ircd_open_fd(((IRCDRES *)Ircd_resconn->conn_ptr)->res_fd,FDLIST_FLAGS_READ, Ircd_resconn, NULL)<0)
+	if (ircd_open_fd(((IRCDRES *)Ircd_resconn->conn_ptr)->res_fd,FDLIST_FLAGS_READ, Ircd_resconn)<0)
 	{
 		fprintf(stderr, "Error putting resfd into fdlist\n");
 		exit(-1);
@@ -1102,15 +1003,10 @@
 	{
 		if (!Coreptr || (*ircdcore_data_size != sizeof(IRCD_DATA)))
 			return -EFAULT;
-		Fdlist_num = Coreptr->Fdlist_num;
 		Conffile = Coreptr->Conffile;
 		ircd_pagesize = Coreptr->ircd_pagesize;
-		Fdlist_main = Coreptr->Fdlist_main;
-		Fdlist_clients = Coreptr->Fdlist_clients;
-		Fdlist_lasttime = Coreptr->Fdlist_lasttime;
 		Ircd_resconn = Coreptr->Ircd_resconn;
 		meptr = Coreptr->meptr;
-		Fds = Coreptr->Fds;
 		Fds_size = Coreptr->Fds_size;
 		Reqlist = Coreptr->ResReqlist;
 		Locals = Coreptr->Locals;
@@ -1123,8 +1019,6 @@
 		Globalinfo = Coreptr->Globalinfo;
 		Rejectholds = Coreptr->Rejectholds;
 		Motd = Coreptr->Motd;
-		Sendbuffersize = Coreptr->Sendbuffersize;
-		Recvbuffersize = Coreptr->Recvbuffersize;
 		Sentalong = Coreptr->Sentalong;
 		Sentalong_marker = Coreptr->Sentalong_marker;
 		Sentalong_end = Coreptr->Sentalong_end;
@@ -1165,19 +1059,11 @@
 	*ircdcore_data_size = sizeof(IRCD_DATA);
 	*ircdcore_data_format_version = 0;
 
-	if (_pfdarray)
-		MyFree(_pfdarray);
-
 	ircdres_deinit_reload(&Coreptr->ResRequests);
 	Coreptr->Conffile = Conffile;
 	Coreptr->ircd_pagesize = ircd_pagesize;
-	Coreptr->Fdlist_num = Fdlist_num;
-	Coreptr->Fdlist_main = Fdlist_main;
-	Coreptr->Fdlist_clients = Fdlist_clients;
-	Coreptr->Fdlist_lasttime = Fdlist_lasttime;
 	Coreptr->Ircd_resconn = Ircd_resconn;
 	Coreptr->meptr = meptr;
-	Coreptr->Fds = Fds;
 	Coreptr->Fds_size = Fds_size;
 	Coreptr->ResReqlist = Reqlist;
 	Coreptr->Locals = Locals;
@@ -1190,8 +1076,6 @@
 	Coreptr->Globalinfo = Globalinfo;
 	Coreptr->Rejectholds = Rejectholds;
 	Coreptr->Motd = Motd;
-	Coreptr->Sendbuffersize = Sendbuffersize;
-	Coreptr->Recvbuffersize = Recvbuffersize;
 	Coreptr->Sentalong = Sentalong;
 	Coreptr->Sentalong_size = Sentalong_size;
 	Coreptr->Sentalong_marker = Sentalong_marker;
@@ -1230,8 +1114,6 @@
 					int *Data_size)
 {
 	int			ret;
-	FDLIST		*curfdlist;
-	int			i;
 
 	if (!Data_format_version || !Data || !Data_size ||
 			!Ircdcore_versionstring)
@@ -1255,7 +1137,6 @@
 	if (!firsttime)
 		send_to_opers("ircd.so has been reloaded");
 
-	curfdlist = Fdlist_main;
 	for(;;)
 	{
 		if (DoRehash)
@@ -1267,6 +1148,13 @@
 
 		if (DoReload)
 		{
+			if (access("./ircd.so", R_OK) < 0)
+			{
+				send_to_opers("Unable to access ircd.so -- reload aborted");
+				DoReload = 0;
+				continue;
+			}
+
 			ret = _ircdso_deinit();
 
 			if (ret < 0)
@@ -1279,21 +1167,7 @@
 			}
 		}
 
-		ret = _ircd_pollfds(curfdlist, 2);
-
-		if (Now >= (Fdlist_lasttime[0] + (int)vars_value_get_bynum(IRCD_VAR_PRIORITY_LAG)))
-		{
-			_ircd_pollfds(&Fdlist_clients[0], 0);
-			Fdlist_lasttime[0] = Now;
-			for(i=1;i<(int)vars_value_get_bynum(IRCD_VAR_PRIORITY_FDLISTS);i++)
-			{
-				if (Now >= (Fdlist_lasttime[i] + ((i+1)*(int)vars_value_get_bynum(IRCD_VAR_PRIORITY_LAG))))
-				{
-					_ircd_pollfds(&Fdlist_clients[i], 0);
-					Fdlist_lasttime[i] = Now;
-				}
-			}
-		}
+		ret = _ircd_pollfds(kqsock, 2);
 
 		{
 			static int	lastcheck = 0;
diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/misc.c ircd-devel/lib/misc.c
--- ircd-comstud-1.12-REL/lib/misc.c	Thu Dec  7 04:26:32 2000
+++ ircd-devel/lib/misc.c	Sun Dec 10 08:50:15 2000
@@ -218,17 +218,14 @@
 		_command_tree_add(cptr->command, cptr);
 }
 
-int ircd_open_fd(int fd, int flags, IRCD_CONN *ptr, FDLIST *fdlistptr)
+int ircd_open_fd(int fd, int flags, IRCD_CONN *ptr)
 {
-	FDLISTINFO	*fdlistinfo;
-
 	if (fd < 0)
 		return -EINVAL;
+
 	if (fd >= Fds_size)
-	{
 		Fds_size = fd + 1024;
-		Fds = (IRCD_CONN **)MyRealloc(Fds, sizeof(IRCD_CONN *) * Fds_size);
-	}
+
 	if (fd >= Sentalong_size)
 	{
 		Sentalong_size = fd + 1024;
@@ -236,37 +233,21 @@
 		Sentalong_end = Sentalong + Sentalong_size;
 		Sentalong_marker = 0; /* next "send" call will 0 Sentalong out */
 	}
-	SET_FDS(fd, ptr);
-	fdlistinfo = &(ptr->fdlistinfo);
-	fdlistinfo->fd = fd;
-	fdlistinfo->fdlist = fdlistptr ? fdlistptr : Fdlist_main;
-	if (flags)
-	{
-		fdlistinfo->fdlist_pos = fdlist_add_fd(fdlistinfo->fdlist, fd, flags);
-		return fdlistinfo->fdlist_pos;
-	}
-	fdlistinfo->fdlist_pos = -1;
+
+	ptr->fd = fd;
+
+	fdlist_add_event(ptr, flags);
+
 	return 0;
 }
 
-int ircd_close_fd(FDLISTINFO *fdlistinfo)
+int ircd_close_fd(int fd)
 {
-	int		ret;
-	int		mfd;
-
-	if (!fdlistinfo || fdlistinfo->fd < 0)
+	if (fd < 0)
 		return -EINVAL;
-	close(fdlistinfo->fd);
-	SET_FDS(fdlistinfo->fd, NULL);
-	if (fdlistinfo->fdlist && fdlistinfo->fdlist_pos >= 0)
-	{
-		ret = fdlist_del_fd(fdlistinfo->fdlist, fdlistinfo->fdlist_pos, &mfd);
-		if ((ret > 0) && (mfd >= 0)) /* update moved fds's position in fdlist */
-		{
-			if (GET_FDS(mfd))
-				GET_FDS(mfd)->fdlistinfo.fdlist_pos = fdlistinfo->fdlist_pos;
-		}
-	}
+
+	close(fd);
+
 	return 0;
 }
 
@@ -292,7 +273,7 @@
     rhptr->rh_rem_ipaddr = ntohl(rem_sin->sin_addr.s_addr);
     rhptr->rh_rem_port = ntohs(rem_sin->sin_port);
 	rhptr->rh_lasttime = rhptr->rh_firsttime = Now;
-    ret = ircd_open_fd(fd, FDLIST_FLAGS_READ, rhptr->rh_connptr, NULL);
+    ret = ircd_open_fd(fd, FDLIST_FLAGS_READ, rhptr->rh_connptr);
     if (ret < 0)
     {
         MyFree(rhptr->rh_connptr);
@@ -318,8 +299,8 @@
 
 		if (sh)
 		{
-			send_to_client(cptr, "NOTICE * :*** Reverse DNS reply received.");
-			send_to_client(cptr, "NOTICE * :*** Doing forward DNS lookup...");
+			send_to_client(cptr, "NOTICE AUTH :*** Reverse DNS reply received.");
+			send_to_client(cptr, "NOTICE AUTH :*** Doing forward DNS lookup...");
 		}
 
 		cptr->c_res_req->rl_reverse = result->res_he;
@@ -329,7 +310,7 @@
 		if ((ret >= 0) && heptr)
 		{
 			if (sh)
-				send_to_client(cptr, "NOTICE * :*** Forward DNS reply received.");
+				send_to_client(cptr, "NOTICE AUTH :*** Forward DNS reply received.");
 			cptr->c_res_req->rl_forward = heptr;
 			del_reqlist_from_list(&Reqlist, cptr->c_res_req);
 			assert(0); /* FIX if we finish dns cache */
@@ -343,14 +324,14 @@
 		else
 		{
 			if (sh)
-				send_to_client(cptr, "NOTICE * :*** Forward DNS request failed.");
+				send_to_client(cptr, "NOTICE AUTH :*** Forward DNS request failed.");
 			del_reqlist_from_list(&Reqlist, cptr->c_res_req);
 		}
 	}
 	else
 	{
 		if (sh)
-			send_to_client(cptr, "NOTICE * :*** Reverse DNS request failed.");
+			send_to_client(cptr, "NOTICE AUTH :*** Reverse DNS request failed.");
 		del_reqlist_from_list(&Reqlist, cptr->c_res_req);
 	}
 	if (!(cptr->c_flags & (CLIENT_FLAGS_DOINGAUTH|CLIENT_FLAGS_DOINGDNS)))
@@ -372,7 +353,7 @@
 		struct in_addr	inaddr;
 
 		if (sh)
-			send_to_client(cptr, "NOTICE * :*** Forward DNS reply received.");
+			send_to_client(cptr, "NOTICE AUTH :*** Forward DNS reply received.");
 
 		cptr->c_res_req->rl_forward = result->res_he;
 
@@ -392,7 +373,7 @@
 	else
 	{
 		if (sh)
-			send_to_client(cptr, "NOTICE * :*** Forward DNS request failed.");
+			send_to_client(cptr, "NOTICE AUTH :*** Forward DNS request failed.");
 	}
 	if (!(cptr->c_flags & CLIENT_FLAGS_DOINGAUTH))
 	{
@@ -459,7 +440,7 @@
         MyFree(cptr);
         return ret;
     }
-    ret = ircd_open_fd(fd, FDLIST_FLAGS_READ, cptr->c_connptr, NULL);
+    ret = ircd_open_fd(fd, FDLIST_FLAGS_READ, cptr->c_connptr);
     if (ret < 0)
     {
         queue_delete(&(cptr->c_queue_in));
@@ -482,7 +463,7 @@
 	sh = (int)vars_value_get_bynum(IRCD_VAR_SHOW_HEADERS);
 
 	if (sh)
-		send_to_client(cptr, "NOTICE * :*** Doing reverse DNS lookup...");
+		send_to_client(cptr, "NOTICE AUTH :*** Doing reverse DNS lookup...");
 
 	ret = ircdres_gethostbyaddr((IRCDRES *)(Ircd_resconn->conn_ptr), &inaddr,
 				(ircdres_func_t)_client_res_callback1, (void *)cptr,
@@ -491,8 +472,8 @@
 	{
 		if (sh)
 		{
-			send_to_client(cptr, "NOTICE * :*** Reverse DNS reply received.");
-			send_to_client(cptr, "NOTICE * :*** Doing forward DNS lookup...");
+			send_to_client(cptr, "NOTICE AUTH :*** Reverse DNS reply received.");
+			send_to_client(cptr, "NOTICE AUTH :*** Doing forward DNS lookup...");
 		}
 		cptr->c_res_req->rl_reverse = heptr;
 		ret = ircdres_gethostbyname((IRCDRES *)(Ircd_resconn->conn_ptr),
@@ -502,7 +483,7 @@
 		if ((ret >= 0) && heptr)
 		{
 			if (sh)
-				send_to_client(cptr, "NOTICE * :*** Forward DNS reply received.");
+				send_to_client(cptr, "NOTICE AUTH :*** Forward DNS reply received.");
 			cptr->c_res_req->rl_forward = heptr;
 		}
 		else if (ret == -EINPROGRESS)
@@ -518,7 +499,7 @@
 	}
 
 	if (sh)
-		send_to_client(cptr, "NOTICE * :*** Connecting for ident request...");
+		send_to_client(cptr, "NOTICE AUTH :*** Connecting for ident request...");
 
 	afd = mysocket_connectip(cptr->c_rem_ipaddr, 113,
 		cptr->c_loc_ipaddr, MYSOCKET_FLAGS_REUSEADDR|MYSOCKET_FLAGS_NONBLOCKING);
@@ -535,7 +516,7 @@
 	    if (ret < 0)
 	    {
 			if (sh)
-				send_to_client(cptr, "NOTICE * :*** Ident request failed: in_queue init failed");
+				send_to_client(cptr, "NOTICE AUTH :*** Ident request failed: in_queue init failed");
 			close(afd);
 	        MyFree(authptr->a_connptr);
 	        MyFree(authptr);
@@ -543,10 +524,10 @@
 			cptr->c_flags &= ~CLIENT_FLAGS_DOINGAUTH;
 	        return 0;
 	    }
-		if (ircd_open_fd(afd, FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE, authptr->a_connptr, NULL) < 0)
+		if (ircd_open_fd(afd, FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE, authptr->a_connptr) < 0)
 		{
 			if (sh)
-				send_to_client(cptr, "NOTICE * :*** Ident request failed: fd init failed");
+				send_to_client(cptr, "NOTICE AUTH :*** Ident request failed: fd init failed");
 			queue_delete(&(authptr->a_queue_in));
 			close(afd);
 	        MyFree(authptr->a_connptr);
@@ -560,14 +541,14 @@
 	else
 	{
 		if (sh)
-			send_to_client(cptr, "NOTICE * :*** Ident request failed.");
+			send_to_client(cptr, "NOTICE AUTH :*** Ident request failed.");
 	}
     return 0;
 }
 
 int rejecthold_del(IRCD_CLIENT *from, IRCD_REJECTHOLD *rptr, char *reason)
 {
-	ircd_close_fd(&(rptr->rh_connptr->fdlistinfo));
+	ircd_close_fd(rptr->rh_connptr->fd);
 	del_rejecthold_from_rhlist(&Rejectholds, rptr);
 	rptr->rh_connptr->conn_ptr = NULL;
 	MyFree(rptr->rh_connptr);
@@ -577,7 +558,7 @@
 
 int auth_del(IRCD_CLIENT *from, IRCD_AUTH *cptr, char *reason)
 {
-	ircd_close_fd(&(cptr->a_connptr->fdlistinfo));
+	ircd_close_fd(cptr->a_connptr->fd);
     queue_delete(&(cptr->a_queue_in));
 	del_auth_from_alist(&Auths, cptr);
 	Auths_did_delete = 1;
@@ -771,13 +752,15 @@
 		MyFree(cptr->c_connectby);
 		cptr->c_connectby = NULL;
 	}
+#if 0
 	client_queue_flush(cptr, NULL);
-	ircd_close_fd(&(cptr->c_connptr->fdlistinfo));
+#endif
+	ircd_close_fd(cptr->c_connptr->fd);
 	cptr->c_connptr->conn_ptr = NULL;
 	MyFree(cptr->c_connptr);
 	cptr->c_connptr = NULL;
-    queue_delete(&(cptr->c_queue_in));
-    queue_delete(&(cptr->c_queue_out));
+	queue_delete(&(cptr->c_queue_in));
+	queue_delete(&(cptr->c_queue_out));
 	cptr->c_flags |= CLIENT_FLAGS_DEAD;
 	assert(IsLocal(cptr));
 	del_client_from_lolist(&Locals, cptr);
@@ -948,7 +931,7 @@
 		{
 			assert(cptr->c_listener->l_clients == NULL);
 			del_listener_from_llist(&(_ircd_conf.listeners), cptr->c_listener);
-			ircd_close_fd(&(cptr->c_listener->l_connptr->fdlistinfo));
+			ircd_close_fd(cptr->c_listener->l_connptr->fd);
 			cptr->c_listener->l_connptr->conn_ptr = NULL;
 			MyFree(cptr->c_listener->l_connptr);
             MyFree(cptr->c_listener);
@@ -1226,17 +1209,17 @@
 
 	if (!src || !(sptr = *src))
 		return NULL;
-	while(*sptr == ',')
+	while(*sptr == ' ')
 		sptr++;
 	if (!*sptr)
 		return NULL;
 	tok = sptr;
-	while(*sptr && *sptr != ',')
+	while(*sptr && *sptr != ' ')
 		sptr++;
 	if (*sptr)
 	{
 		*sptr++ = '\0';
-		while(*sptr == ',')
+		while(*sptr == ' ')
 			sptr++;
 		*src = sptr;
 	}
@@ -1288,14 +1271,13 @@
 
 		ret = queue_data_get(&(cptr->c_queue_out), &ptr, &len);
 		assert(ret >= 0);
-		ret = write(cptr->c_connptr->fdlistinfo.fd, ptr, len);
+		ret = write(cptr->c_connptr->fd, ptr, len);
 		if (ret > 0)
 		{
 			if (IsClient(cptr))
 				Globalinfo->bw_c_outgoing_bytes += ret;
 			else if (IsServer(cptr))
 				Globalinfo->bw_s_outgoing_bytes += ret;
-			cptr->c_writetries = 0;
 			queue_data_del(&(cptr->c_queue_out), ret);
 			if (ret == len)
 				continue;
@@ -1320,9 +1302,10 @@
 		}
 		break;
 	}
+
 	if (!(cptr->c_lastqsize = cptr->c_queue_out.queue_size))
-		fdlist_del_event(cptr->c_connptr->fdlistinfo.fdlist,
-			cptr->c_connptr->fdlistinfo.fdlist_pos, FDLIST_FLAGS_WRITE);
+		fdlist_del_event(cptr->c_connptr, FDLIST_FLAGS_WRITE);
+
 	return 0;
 }
 
diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/numeric.c ircd-devel/lib/numeric.c
--- ircd-comstud-1.12-REL/lib/numeric.c	Sun Oct 22 21:52:24 2000
+++ ircd-devel/lib/numeric.c	Tue Dec  5 12:40:50 2000
@@ -51,10 +51,10 @@
 {
 /* 200 */	{	RPL_TRACELINK,			"Link %s%s %s %s" },
 /* 201 */	{	RPL_TRACECONNECTING,	"Try. %s %s" },
-/* 202 */	{	RPL_TRACEHANDSHAKE,		"H.S. %s %s" },
-/* 203 */	{	RPL_TRACEUNKNOWN,		"???? %s %s" },
-/* 204 */	{	RPL_TRACEOPERATOR,		"Oper %s %s" },
-/* 205 */	{	RPL_TRACEUSER,			"User %s %s" },
+/* 202 */	{	RPL_TRACEHANDSHAKE,		"H.S. %s %s (%s)" },
+/* 203 */	{	RPL_TRACEUNKNOWN,		"???? %s %s (%s)" },
+/* 204 */	{	RPL_TRACEOPERATOR,		"Oper %s %s (%s)" },
+/* 205 */	{	RPL_TRACEUSER,			"User %s %s (%s)" },
 /* 206 */	{	RPL_TRACESERVER,		"Serv %s %dS %dC %s %s" },
 /* 207 */	{	RPL_TRACESERVICE,		"Service %s %s" },
 /* 208 */	{	RPL_TRACENEWTYPE,		"<newtype> 0 %s" },
